=== debian/changelog ===
colmap (3.4-1) unstable; urgency=medium

  * Initial release. (Closes: #882326)

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Fri, 05 Jan 2018 10:10:47 +0100
